
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Pos_registersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pos_registers = await db.pos_registers.create(
            {
                id: data.id || undefined,
        
        register_name: data.register_name
        ||
        null
            ,
            
        register_code: data.register_code
        ||
        null
            ,
            
        has_cash_drawer: data.has_cash_drawer
        ||
        false
        
            ,
            
        has_receipt_printer: data.has_receipt_printer
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await pos_registers.setBranch( data.branch || null, {
            transaction,
        });
        
        await pos_registers.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return pos_registers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const pos_registersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                register_name: item.register_name
            ||
            null
            ,
            
                register_code: item.register_code
            ||
            null
            ,
            
                has_cash_drawer: item.has_cash_drawer
            ||
            false
        
            ,
            
                has_receipt_printer: item.has_receipt_printer
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const pos_registers = await db.pos_registers.bulkCreate(pos_registersData, { transaction });

        // For each item created, replace relation files
        

        return pos_registers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const pos_registers = await db.pos_registers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.register_name !== undefined) updatePayload.register_name = data.register_name;
        
        
        if (data.register_code !== undefined) updatePayload.register_code = data.register_code;
        
        
        if (data.has_cash_drawer !== undefined) updatePayload.has_cash_drawer = data.has_cash_drawer;
        
        
        if (data.has_receipt_printer !== undefined) updatePayload.has_receipt_printer = data.has_receipt_printer;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await pos_registers.update(updatePayload, {transaction});

        
        
        if (data.branch !== undefined) {
            await pos_registers.setBranch(
              
              data.branch,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await pos_registers.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return pos_registers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pos_registers = await db.pos_registers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of pos_registers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of pos_registers) {
                await record.destroy({transaction});
            }
        });


        return pos_registers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const pos_registers = await db.pos_registers.findByPk(id, options);

        await pos_registers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await pos_registers.destroy({
            transaction
        });

        return pos_registers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const pos_registers = await db.pos_registers.findOne(
            { where },
            { transaction },
        );

        if (!pos_registers) {
            return pos_registers;
        }

        const output = pos_registers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.pos_shifts_register = await pos_registers.getPos_shifts_register({
            transaction
        });
        
        
        output.sales_register = await pos_registers.getSales_register({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.branch = await pos_registers.getBranch({
            transaction
        });
        
        
        output.organizations = await pos_registers.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.branches,
        as: 'branch',
        
        where: filter.branch ? {
          [Op.or]: [
            { id: { [Op.in]: filter.branch.split('|').map(term => Utils.uuid(term)) } },
            {
              branch_name: {
                [Op.or]: filter.branch.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.register_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pos_registers',
                        'register_name',
                        filter.register_name,
                    ),
                };
            }
            
            if (filter.register_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pos_registers',
                        'register_code',
                        filter.register_code,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.has_cash_drawer) {
                where = {
                    ...where,
                has_cash_drawer: filter.has_cash_drawer,
            };
            }
            
            if (filter.has_receipt_printer) {
                where = {
                    ...where,
                has_receipt_printer: filter.has_receipt_printer,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.pos_registers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'pos_registers',
                        'register_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.pos_registers.findAll({
            attributes: [ 'id', 'register_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['register_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.register_name,
        }));
    }

    
};

